'use strict';
module.exports = function anonymous(it) {
  var out = '';
  if (it.isTop) {
    var $top = it.isTop,
      $lvl = it.level = 0,
      $dataLvl = it.dataLevel = 0,
      $data = 'data';
    it.rootId = it.baseId = it.resolve.fullPath(it.root.schema.id);
    delete it.isTop;
    it.wasTop = true;
    out += ' validate = function (data, dataPath) { \'use strict\'; validate.errors = null;';
    out += ' var errors = 0;        ';
  } else {
    if (it.opts._debug) {
      out += ' console.log(\'validate dataPath:\', dataPath); ';
    }
    var $lvl = it.level,
      $dataLvl = it.dataLevel,
      $data = 'data' + ($dataLvl || '');
    if (it.schema.id) it.baseId = it.resolve.url(it.baseId, it.schema.id);
    delete it.wasTop;
    out += ' var errs_' + ($lvl) + ' = errors;';
  }
  var $valid = 'valid' + $lvl,
    $breakOnError = !it.opts.allErrors,
    $closingBraces1 = '',
    $closingBraces2 = '';
  var $typeSchema = it.schema.type;
  var arr1 = it.RULES;
  if (arr1) {
    var $rulesGroup, i1 = -1,
      l1 = arr1.length - 1;
    while (i1 < l1) {
      $rulesGroup = arr1[i1 += 1];
      if ($shouldUseGroup($rulesGroup)) {
        if ($rulesGroup.type) {
          out += ' if (' + (it.util.checkDataType($rulesGroup.type, $data)) + ') { ';
        }
        var arr2 = $rulesGroup.rules;
        if (arr2) {
          var $rule, i2 = -1,
            l2 = arr2.length - 1;
          while (i2 < l2) {
            $rule = arr2[i2 += 1];
            if ($shouldUseRule($rule)) {
              out += ' ' + ($rule.code(it)) + ' ';
              if ($breakOnError) {
                $closingBraces1 += '}';
              }
            }
          }
        }
        if ($breakOnError) {
          out += ' ' + ($closingBraces1) + ' ';
          $closingBraces1 = '';
        }
        if ($rulesGroup.type) {
          out += ' } ';
          if ($typeSchema && $typeSchema === $rulesGroup.type) {
            var $typeChecked = true;
            out += ' else {  ';
            if (it.wasTop && $breakOnError) {
              out += ' validate.errors = [ { keyword: \'' + ('type') + '\', dataPath: (dataPath || \'\') + ' + (it.errorPath) + ', message: \'should be ';
              if ($isArray) {
                out += '' + ($typeSchema.join(","));
              } else {
                out += '' + ($typeSchema);
              }
              out += '\' ';
              if (it.opts.verbose) {
                out += ', schema: ';
                if ($isArray) {
                  out += 'validate.schema' + ($schemaPath);
                } else {
                  out += '\'' + ($typeSchema) + '\'';
                }
                out += ', data: ' + ($data);
              }
              out += ' }]; return false; ';
            } else {
              out += '  var err =   { keyword: \'' + ('type') + '\', dataPath: (dataPath || \'\') + ' + (it.errorPath) + ', message: \'should be ';
              if ($isArray) {
                out += '' + ($typeSchema.join(","));
              } else {
                out += '' + ($typeSchema);
              }
              out += '\' ';
              if (it.opts.verbose) {
                out += ', schema: ';
                if ($isArray) {
                  out += 'validate.schema' + ($schemaPath);
                } else {
                  out += '\'' + ($typeSchema) + '\'';
                }
                out += ', data: ' + ($data);
              }
              out += ' }; if (validate.errors === null) validate.errors = [err]; else validate.errors.push(err); errors++; ';
            }
            out += ' } ';
          }
        }
        if ($breakOnError) {
          out += ' if (errors === ';
          if ($top) {
            out += '0';
          } else {
            out += 'errs_' + ($lvl);
          }
          out += ') { ';
          $closingBraces2 += '}';
        }
      }
    }
  }
  if ($typeSchema && !$typeChecked) {
    var $schemaPath = it.schemaPath + '.type',
      $isArray = Array.isArray($typeSchema),
      $method = $isArray ? 'checkDataTypes' : 'checkDataType';
    out += ' if (' + (it.util[$method]($typeSchema, $data, true)) + ') {  ';
    if (it.wasTop && $breakOnError) {
      out += ' validate.errors = [ { keyword: \'' + ('type') + '\', dataPath: (dataPath || \'\') + ' + (it.errorPath) + ', message: \'should be ';
      if ($isArray) {
        out += '' + ($typeSchema.join(","));
      } else {
        out += '' + ($typeSchema);
      }
      out += '\' ';
      if (it.opts.verbose) {
        out += ', schema: ';
        if ($isArray) {
          out += 'validate.schema' + ($schemaPath);
        } else {
          out += '\'' + ($typeSchema) + '\'';
        }
        out += ', data: ' + ($data);
      }
      out += ' }]; return false; ';
    } else {
      out += '  var err =   { keyword: \'' + ('type') + '\', dataPath: (dataPath || \'\') + ' + (it.errorPath) + ', message: \'should be ';
      if ($isArray) {
        out += '' + ($typeSchema.join(","));
      } else {
        out += '' + ($typeSchema);
      }
      out += '\' ';
      if (it.opts.verbose) {
        out += ', schema: ';
        if ($isArray) {
          out += 'validate.schema' + ($schemaPath);
        } else {
          out += '\'' + ($typeSchema) + '\'';
        }
        out += ', data: ' + ($data);
      }
      out += ' }; if (validate.errors === null) validate.errors = [err]; else validate.errors.push(err); errors++; ';
    }
    out += ' }';
  }
  if ($breakOnError) {
    out += ' ' + ($closingBraces2) + ' ';
  }
  if ($top) {
    out += ' return errors === 0;';
    out += ' }';
  } else {
    out += ' var ' + ($valid) + ' = errors === errs_' + ($lvl) + ';';
  }
  out = it.util.cleanUpCode(out);
  if ($top && $breakOnError) {
    out = it.util.cleanUpVarErrors(out);
  }

  function $shouldUseGroup($rulesGroup) {
    return $rulesGroup.rules.some(function($rule) {
      return $shouldUseRule($rule);
    });
  }

  function $shouldUseRule($rule) {
    return it.schema[$rule.keyword] !== undefined || ($rule.keyword == 'properties' && (it.schema.additionalProperties !== undefined || (it.schema.patternProperties && Object.keys(it.schema.patternProperties).length)));
  }
  return out;
}
